const { ccclass, property } = cc._decorator;

@ccclass
export default class Helloworld extends cc.Component {

    @property(cc.Label)
    label: cc.Label = null;
    @property(cc.Prefab)
    layer1: cc.Prefab = null;

    start() {

    }

    addLayerBtnEvent(): void {
        let prefabPath = 'prefab/layer';
        cc.resources.load(prefabPath, function (error, prefab) {
            prefab.addRef()
            let layer = cc.instantiate(prefab);
            let script = layer.getComponent('layer');
            script.setPrefab(prefab);
            this.node.addChild(layer);
        }.bind(this))
    }
}
