"use strict";
cc._RF.push(module, 'c38c7CXIg9JarsFPHyIEJHX', 'layer');
// Script/layer.ts

"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var _a = cc._decorator, ccclass = _a.ccclass, property = _a.property;
var Layer = /** @class */ (function (_super) {
    __extends(Layer, _super);
    function Layer() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.animNode = null;
        _this._m_prefab = null;
        _this.resArray = null;
        return _this;
    }
    Layer.prototype.onLoad = function () {
        this.resArray = [];
    };
    Layer.prototype.start = function () {
    };
    Layer.prototype.setPrefab = function (prefab) {
        this._m_prefab = prefab;
    };
    Layer.prototype.backEvent = function () {
        this.releaseRes();
        this.node.destroy();
        cc.log("remove");
    };
    Layer.prototype.releaseRes = function () {
        cc.assetManager.releaseAsset(this._m_prefab);
        for (var i = 0; i < this.resArray.length; i++) {
            cc.assetManager.releaseAsset(this.resArray[i]);
        }
        cc.log('release');
    };
    Layer.prototype.loadArm = function () {
        this.playLocalDragAnimationByName(this.animNode, 'texture/fankui', 'Sprite');
    };
    Layer.prototype.playLocalDragAnimationByName = function (node, url, armatureName) {
        var _this = this;
        if (!node) {
            return;
        }
        cc.resources.loadDir(url, function (err, assets) {
            if (err) {
                return;
            }
            if (assets.length <= 0) {
                return;
            }
            for (var i = 0; i < assets.length; i++) {
                if (assets[i] instanceof cc.SpriteFrame) {
                    _this.resArray.push(assets[i]);
                }
            }
            var armatureDisplay = node.addComponent(dragonBones.ArmatureDisplay);
            for (var elem in assets) {
                if (assets[elem] instanceof dragonBones.DragonBonesAsset) {
                    if (armatureDisplay.dragonAsset != assets[elem]) {
                        armatureDisplay.dragonAsset = assets[elem];
                        _this.resArray.push(assets[elem]);
                    }
                }
                if (assets[elem] instanceof dragonBones.DragonBonesAtlasAsset) {
                    if (armatureDisplay.dragonAtlasAsset != assets[elem]) {
                        armatureDisplay.dragonAtlasAsset = assets[elem];
                        _this.resArray.push(assets[elem]);
                    }
                }
            }
            armatureDisplay.armatureName = "Sprite";
            armatureDisplay.playAnimation("Sprite", 1);
            armatureDisplay.timeScale = 1;
        });
    };
    /**
     * @method 通过Armature获取指定的object
     */
    Layer.prototype.getObjectByArmature = function (armatureArray, armatureName) {
        if (!armatureArray || armatureArray.length === 0)
            return null;
        for (var i = 0; i < armatureArray.length; i++) {
            if (armatureName === armatureArray[i].name) {
                return armatureArray[i];
            }
        }
    };
    __decorate([
        property(cc.Node)
    ], Layer.prototype, "animNode", void 0);
    Layer = __decorate([
        ccclass
    ], Layer);
    return Layer;
}(cc.Component));
exports.default = Layer;

cc._RF.pop();